== Changelog ==

= 9.4.1 - 26-02-2026 =
* Fix: Fixed quantity based on field in bulk pricing for variations templates.
* Fix: Use product->is_type method to better support variation and variable products.
* Update: Verified compatibility with WooCommerce 10.5.2

= 9.4.0 - 16-02-2026 =
* New: Performance improvement on get_available_variatoins for variable products.
* Fix: Fixed issues on some of pre-built templates configurations.
* Fix: Fixed issues on updating variable/variation product prices with bulk pricing rules.
* Update: Verified compatibility with WooCommerce 10.5.1

= 9.3.0 - 27-01-2026 =
* New: Added "Add from Template" button for the rules in the admin side to create rules quickly & easily with just a few edits.
* Fix: Added a compatibility for the Porto theme skeleton feature for bulk pricing rules table.
* Update: Verified compatibility with WooCommerce 10.4.3

= 9.2.1 - 08-12-2025 =
* Update: Verified compatibility with WordPress 6.9
* Update: Verified compatibility with WooCommerce 10.3.6

= 9.2.0 - 24-11-2025 =
* New: Added recurring discount types for the WooCommerce subscriptions plugin.

= 9.1.1 - 18-11-2025 =
* Fix: Fixed an issue in getting customer bought products.
* Fix: Fixed select2 deprecated message issue in woocommerce 10.3.
* Fix: Fixed analytics disabled issue for counting impressions.

= 9.1.0 - 06-11-2025 =
* New: Added negative value support for checkout fees that works like a discount.
* Fix: Fixed an issue of counting pricing rules impression when analytics is disabled.
* Update: Verified compatibility with WooCommerce 10.3.4

= 9.0.0 - 22-10-2025 =
* New: Added rules analytics to the plugin admin page.
* Update: Verified compatibility with WooCommerce 10.2.2

= 8.22.1 - 09-09-2025 =
* Fix: Fixed the total discount issue with product bundle plugin.
* Update: Verified compatibility with WooCommerce 10.1.2

= 8.22.0 - 07-08-2025 =
* New: Added "Cart discount rules" support to the "Coupons applied" condition.
* Update: Verified compatibility with WooCommerce 10.0.4.

= 8.21.0 - 07-07-2025 =
* New: Added a "Buy x Get x - same product" option to create Buy One Get One deals for the same product with a single rule.
* New: Added product page messages for all pricing rules to better inform customers.
* Fix: Resolved a null cart issue in the Store API.
* Update: Verified compatibility with WooCommerce 9.9.5.

= 8.20.1 - 28-05-2025 =
* Fixed regular price issue in WholeSale Prices plugin compatibility.

= 8.20.0 - 13-05-2025 =
* Added a compatibility with WooCommerce WholeSale Prices.
* Fixed price suffix issue in the quantity table.
* Verified compatibility with WooCommerce version 9.8.5.

= 8.19.1 - 02-05-2025 =
* Fixed the live price compatibility issue with Extra Product Options.
* Verified compatibility with WooCommerce version 9.8.3.

= 8.19.0 - 22-04-2025 =
* Added usage restrictions to the rules.
* Added usage restrictions per user to the rules.
* Verified compatibility with WooCommerce version 9.8.1.
* Verified compatibility with WordPress version 6.8.

= 8.18.4 - 18-03-2025 =
* Fixed an issue in getting applied couopn with WooCommerce cart block.
* Fixed an issue in checking pricing existance.
* Updated the plugin update library.
* Verified compatibility with WooCommerce version 9.7.1.

= 8.18.3 - 11-02-2025 =
* Fixed a compatibility issue with currency switcher plugins.
* Verified compatibility with WooCommerce version 9.6.1.

= 8.18.2 - 28-01-2025 =
* Fixed change product price issue with bulk pricing rules.
* Verified compatibility with WooCommerce version 9.6.0.

= 8.18.1 - 11-12-2024 =
* Fixed an issue in changing product bundle price.

= 8.18.0 - 10-12-2024 =
* Checkout Fees adjusted to consider if the subtotal includes or excludes tax based on cart configuration.
* Verified compatibility with WooCommerce version 9.4.3.

= 8.17.0 - 01-12-2024 =
* Added basic compatibility of simple pricing rules with Product Bundle Builder plugin.
* Verified compatibility with WooCommerce version 9.4.2.

= 8.16.1 - 11-11-2024 =
* Fixed an issue with individual use manual coupons.

= 8.16.0 - 28-10-2024 =
* Added "subtotal including tax excluding coupons" condition to the shipping methods, shipping discount, checkout fees, auto add products rules.
* Added "subtotal excluding tax excluding coupons" condition to the shipping methods, shipping discount, checkout fees, auto add products rules.

= 8.15.0 - 30-09-2024 =
* Resolved an issue with manual coupons.
* Fixed a pricing update issue for bulk pricing rules in simple products.
* Verified compatibility with WooCommerce version 9.3.3.

= 8.14.0 - 17-09-2024 =
* Introduced a new option for bulk pricing rules in the plugin settings that allows to automatically update the product price based on variation price changes when a variation is selected.
* Verified compatibility with WooCommerce version 9.3.1.

= 8.13.0 - 05-09-2024 =
* Added an option to toggle between client-side or server-side handling for bulk pricing rule adjustments.
* Resolved an issue affecting product variation price changes under bulk pricing rules.
* Corrected a problem with the wccs_change_cart_item_price filter hook.
* Addressed a compatibility issue with manual coupons in the WooCommerce REST API.
* Fixed a total price calculation issue in the live price feature.
* mproved compatibility with WooCommerce Payments to resolve specific conflicts.
* Fixed an issue where removing cart discount coupons interfered with checkout fee rules.
* Verified compatibility with WooCommerce version 9.2.3.
* Verified compatibility with WordPress version 6.6.1.

= 8.12.0 - 04-07-2024 =
* Added manual coupons feature that makes a cart discount rule similar to a manual coupon.
* Verified compatibility with WooCommerce version 9.0.2.

= 8.11.0 - 13-06-2024 =
* Added an option to Enable/Disable free gift emoji 🎁 in the cart and checkout.
* Fixed free gift emoji styles.

= 8.10.0 - 11-06-2024 =
* Added compatibility for auto-added products with cart and checkout blocks.
* Added a free gift emoji 🎁 to the free items in the cart and checkout.
* Added WPML compatibility for cart items categories, tags, attributes, and taxonomies conditions.
* Fixed issues with categories, tags, attributes, and taxonomies in cart conditions.
* Verified compatibility with WooCommerce version 8.9.3.

= 8.9.0 - 05-06-2024 =
* Fixed an issue in grouped product discount types.
* Fixed the discounted products shortcode issue with WPML multilingual.
* Verified compatibility with WooCommerce version 8.9.2.

= 8.8.0 - 09-05-2024 =
* Added a custom cache table to store plugin data such as pricing, quantity tables, messages, badges, and more, improving performance.
* Introduced options to selectively disable caching of prices, quantity tables, messages, and badges, providing more flexibility.
* Resolved an issue where the product price suffix was not properly displayed with tax in the quantity table prices.
* Fixed quantity table compatibility issues with some third-party styles.
* Verified compatibility with WooCommerce version 8.8.3.

= 8.7.1 - 20-04-2024 =
* Fixed change product price issue with bulk pricing rules on product page.

= 8.7.0 - 18-04-2024 =
* Added a compatibility with Elementor mini-cart.
* Verified compatibility with WordPress version 6.5.2.
* Verified compatibility with WooCommerce version 8.8.2.

= 8.6.2 - 19-03-2024 =
* Resolved problems with verifying quantity according to category.
* Address an issue with verifying the auto-add rule.

= 8.6.1 - 17-03-2024 =
* Resolved issues related to changing product prices on the product page to accommodate bulk pricing rules.

= 8.6.0 - 13-03-2024 =
* Implemented a feature allowing modification of product prices using bulk pricing rule ranges.
* Integrated WooCommerce on-sale products into the [wccs_discounted_products] shortcode.
* Verified compatibility with WooCommerce version 8.6.1.

= 8.5.1 - 31-01-2024 =
* Fixed an issue in showing price range for the bulk pricing rules on the product and archive page.
* Ensure compatibility with WooCommerce 8.5.2

= 8.5.0 - 24-01-2024 =
* Change product price based on bulk pricing rules on archive and product page.
* Ensure compatibility with WooCommerce 8.5.1

= 8.4.0 - 27-12-2023 =
* Implemented a filter hook to disable changing the cart item price.
* Implemented a cache mechanism for discounted products.
* Resolved the issue where the countdown timer was not being displayed after adding OR conditions.
* Ensured compatibility with WooCommerce 8.4.0

= 8.3.1 - 16-11-2023 =
* Fixed an issue in add new button for products group rules.

= 8.3.0 - 16-11-2023 =
* Fixed add products issue to the product bundle or group rules.
* Fixed add products issue to the products list rules.
* Ensure compatibility with WordPress 6.4
* Ensure compatibility with WooCommerce 8.2.2

= 8.2.0 - 26-10-2023 =
* Fix issues in the plugin rules creation interface.

= 8.1.0 - 09-10-2023 =
* Added Run the Updater button to update required message in the plugin page.

= 8.0.0 - 03-10-2023 =
* Support for OR conditions, products and exclude products is added.
* Fix an issue in validating product variations.
* Compatibility with WooComemrce 8.1.1

= 7.14.0 - 10-08-2023 =
* Add WooCommerce HPOS(High Performance Order Storage) support.
* Lock quantity change for auto added products in Woodmart theme mini cart.
* Lock quantity change for auto added products in checkout.
* Make WCCS_Cart_Totals more compatible with PHP 8.2 and above.
* Fix check cart initialized on validating conditinos.
* Update on sale products default price to onsale price.
* Update cart discount apply method to all of applicable rules.
* Update checkout feeds apply method to all of applicable rules.
* Compatibility with WooComemrce 8.0.1
* Compatibility with WordPress 6.3

= 7.13.0 - 19-07-2023 =
* Fix an issue in checking product simple attributes in conditions.
* Fix an issue in checking variation attributes in orders.
* Compatibility with WooComemrce 7.9.0

= 7.12.1 - 04-07-2023 =
* Fix $this issue in the rules helpers class after 7.12.0 update.

= 7.12.0 - 03-07-2023 =
* Fix variation product issue with product attributes validator.
* Add base of rest api classes.
* Compatibility with WooCommerce 7.8.1

= 7.11.0 - 20-06-2023 =
* Add server time component to the date time field.
* Fix validating time when 12 am is in the time.

= 7.10.0 - 15-06-2023 =
* Added an option to remove auto added products for URL Coupons and Auto Add Products addon.
* Compatibility with WooCommerce 7.8.0

= 7.9.2 - 07-06-2023 =
* Use apply sum of discounts for cart discounts as default value.
* Compatibility with WooComemrce 7.7.2

= 7.9.1 - 18-05-2023 =
* Fix : Fix apply price discounts when discount amount is greater than the product price.
* Compatibility with WooComemrce 7.7.0

= 7.9.0 - 27-04-2023 =
* New : Add exchange price to subtotal conditions.
* Fix : Fix an issue in validating product attributes.
* Compatibility with WooComemrce 7.6.1

= 7.8.0 - 10-04-2023 =
* New : Add class name to auto added products in cart.
* Compatibility with WordPress 6.2
* Compatibility with WooCommerce 7.5.1

= 7.7.0 - 20-03-2023 =
* New : Added select products by attributes in the discounted products shortcode.
* Compatibility with WooCommerce 7.5.0

= 7.6.0 - 27-02-2023 =
* Fix : Rename the json language file.
* Compatibility with WooCommerce 7.4.0

= 7.5.0 - 26-01-2023 =
* Fix : Fix PHP 8.2 dynamic property issue.
* Compatibility with WooCommerce 7.3.0

= 7.4.1 - 05-01-2023 =
* Fix : Fix cart not init fatal error on admin.
* Compatibility with WooCommerce 7.2.2

= 7.4.0 - 20-12-2022 =
* New : Add a feature to list shipping methods in the Cash On Delivery payment method settings.
* Fix : Fix string * float issue in php 8
* Compatibility with WooCommerce 7.2.1

= 7.3.0 - 21-11-2022 =
* New : Add an option to remove zero values from zero amount coupons.
* Compatibility with WooCommerce 7.1.0

= 7.2.1 - 07-11-2022 =
* Rename author of the plugin to the "Discount Rules and Dynamic Pricing for WooCommerce Team".

= 7.2.0 - 03-11-2022 =
* New : Add price suffix to the live price.
* New : Remove woocommerce sale badge from simple pricing rules when it is disabled in the plugin settings.
* Compatibility with WordPress 6.1
* Compatibility with WooCommerce 7.0.1

= 7.1.0 - 16-10-2022 =
* Compatibility with WooCommerce 7.0.0

= 7.0.0 - 06-10-2022 =
* New : Added compatibility with WPML.
* Fix : Fix an issue in cart discount rules when applied a limit on them.
* Compatibility check with WooCommerce 6.9.4

= 6.10.0 - 06-09-2022 =
* New : Allow bundle products for auto add to the cart.
* New : Support 0 value for URL Coupons for WooCommerce.
* Fix : Fix issue of displaying quantity table when product does not exists.
* Fix : Fix issue of displaying purchase message when product does not exists.
* Fix : Import validators in a right way to support treeshaking.
* Compatibility check with WooCommerce 6.8.2

= 6.9.0 - 02-08-2022 =
* New : Add stock management option to the quantity table settings.
* New : Add compatibility with product filter plugins for products list shortcodes.
* Fix : Fix the live price issue with the TM EPO Extra Product Options plugin.
* Fix : Fix dispalying the live price when elements added after page load.
* Fix : Fix order by price issue in the discounted products shortcode.
* Fix : Fix call to undefined method should_change_display_price_html in the sale flash shortcode.
* Fix : Check product exists in auto add to cart.
* Compatibility check with WooCommerce 6.7.0

= 6.8.0 - 28-06-2022 =
* New : Add an option to the performance tab to control search items limit value.
* Fix : Fix compatibility issue with CURCY Multi Currency for WooCommerce premium plugin.
* Fix : Fix the quantity table discount value when taxes are enabled.
* Compatibility check with WooCommerce 6.6.1

= 6.7.1 - 26-05-2022 =
* Minor bug fix.
* Compatibility check with WordPress 6.0

= 6.7.0 - 17-05-2022 =
* New : Adding a compatibility for the CURCY Multi Currency for WooCommerce plugin.
* Fix : Fix an issue in shipping methods conditions.
* Fix : Fix issue in checkout fee amount when it is include or exclude taxes.
* Compatibility check with WooCommerce 6.5.1

= 6.6.0 - 14-04-2022 =
* New : Adding fixed price discount type to the cart discount rules.
* Fix : Fixing an issue in sale_flash shortcode.
* Fix : Adding limit to search products and variations.
* Fix : Fix an issue in checking weight, lenght, width and height conditions.
* Fix : Fix applying pricing rules with WooCommerce subscriptions.
* Dev : Adding wccs_public_cart_item_pricing_get_price filter hook.
* Dev : Adding wccs_public_cart_item_pricing_get_prices filter hook.
* Dev : Adding wccs_public_cart_item_pricing_get_ranges_prices filter hook.
* Compatibility check with WooCommerce 6.4.0

= 6.5.0 - 07-03-2022 =
* Fix : Fixing an issue in auto add product rules when product is a variable product.
* Fix : Fixing an issue in auto add products to the cart when discount type is fixed_price.
* Fix : Fix issue of generating cart_item_data for auto add products.
* Fix : Exchange price and price_per_item discount types in coupons.
* Compatibility check with WooCommerce 6.2.1

= 6.4.0 - 07-02-2022 =
* New : Adding comma separated list support for meta field conditions.
* New : Adding comma separated list support for city condition.
* Fix : Return product price when discount is not available in the quantity table.
* Fix : Fix polyfills issue in older wordpress versions.
* Fix : Fix an issue in the WooCommerce product bundles compatibility.
* Compatibility check with WooCommerce 6.1.1
* Compatibility check with Wordpress 5.9

= 6.3.1 - 30-12-2021 =
* Fix : Fixing a fatal error in getting purchase pricing rules after the 6.3.0 update.

= 6.3.0 - 28-12-2021 =
* New : New algorightm for auto add products in bogo deals which supports add/remove gift products based on buy product changes.
* New : Adding search by title and type for shipping methods.
* New : Adding an option to control apply first discounts on expensive or chepeast products for tiered pricing rules.
* New : Adding email conditions.
* Fix : Fixing issues in database update.
* Compatibility check with WooCommerce 6.0.0

= 6.2.0 - 05-12-2021 =
* New : Adding support for the URL Coupons for WooCommerce adddon.
* Tweak : Checking billing email for guest users in conditinos.
* Fix : Fixing an issue in products multi select when it has more items.
* Compatibility check with WooCommerce 5.9.0

= 6.1.0 - 27-10-2021 =
* New : Adding compatibility for the WooCommerce All Products For Subscriptions plugin.
* New : Adding compatibility for the WooCommerce cart block.
* New : Adding compatibility for the WooCommerce checkout block.
* Fix : compatibility issue with WooCommerce subscription.
* Fix : Fixing a compatibility issue with UNI CPO product options plugin.
* Fix : Replace display quantity text with display price typo in the bulk discount rule.
* Fix : Fix total discounts compatibility issue with WooCommerce Currency Switcher plugin or WOOCS.
* Fix : Delete button issue in the rules list.
* Fix : Do not use price suffix for the discounted price.
* Compatibility check with WooCommerce 5.8.0

= 6.0.0 - 15-09-2021 =
* New : New UI for the backned of the plugin.
* New : Adding a new feature to support addons.
* New : Using ajax request to select categories, tags and attributes.
* New : Adding compatibility for the WooCommerce All Products For Subscriptions plugin.
* Fix : compatibility issue with Improved Product Options for WooCommerce plugin.
* Compatibility check with WooCommerce 5.6.0

= 5.2.1 - 07-08-2021 =
* Fix : Compatibility of cart discounts with WooCommerce subscriptions.
* Compatibility check with WooCommerce 5.5.2
* Compatibility check with Wordpress 5.8

= 5.2.0 - 13-07-2021 =
* New : Added compatibility with WooCommerce brands or Product Brands for WooCommerce plugin.
* New : Added conditions for product custom taxonomies.
* New : Added a feature to filter products by product custom taxonomies.
* Fix : Fixed subtotal condition issues in the pricing rules.
* Fix : Fixing setting discounted products as onsale products in the cart.

= 5.1.0 - 14-06-2021 =
* New : Adding compatibility with WooCommerce product bundles plugin.
* New : Using "percent" and "fixed_product" coupon types in cart discounts.
* Fix : Fixing pricing issues with WPC product bundles plugin.
* Fix : Fixing issue of applying coupon on specific products.
* Fix : BOGO deal does not work properly if the Get item is inside the Buy items.
* Fix : Auto add products, do not add free product to the cart when decreasing quantities in the cart.
* Compatibility check with WooCommerce 5.4.1

= 5.0.0 - 20-05-2021 =
* Fix : Fixing issue of Auto add products to cart does not add valid quantities when Get product is already in the cart.
* Fix : Fixing an issue in checking products existstance when type is all or only.
* Tweak : Disable Total Discounts feature by default.
* Compatibility check with WooCommerce 5.3.0

= 4.14.0 - 07-04-2021 =
* Fix : Fixing an issue of the products list in some themes like Astra theme.
* Fix : Fixing an issue in the plugin update checker.
* Fix : Fixing an issue in found_variation and hide_variation events.

= 4.13.0 - 11-03-2021 =
* New : Adding a compatibility with the Product Feed Pro plugin.
* Fix : Using billing email for logged in users.
* Fix : Discounted price revert to original price in checkout when "Consider Product Sale Price" option is enabled.
* Fix : Fixing issue of float numbers in setting applied prices.
* Fix : Fixing an issue in the cart item prices when using a BOGO deal.
* Fix : Removing notices from the plugin pages in the admin.
* Compatibility check with Wordpress 5.7
* Compatibility check with WooCommerce 5.1.0

= 4.12.0 - 06-02-2021 =
* New : WPC Product Bundles basic compatibility added.
* New : Measurement price calculator plugin compatibility added.
* Fix : Fixing issue of variable product prices inside the quantity table when taxes applied.
* Rename : Rename the plugin to Discount Rules and Dynamic Pricing for WooCommerce.

= 4.11.0 - 13-01-2021 =
* New : Adding a condition for user is not logged in.
* New : Adding consider product onsale price option when applying max or min discounts.
* New : Adding a feature to add free product to the cart when quantity chanegs inside the cart.
* New : Using in cart price for the product quantities that don't get the discount on applying discounts.
* Fix : Fixing an issue in listening quantity change events in the product page.
* Fix : Fixing issue of not considering excluded items from purchase products in the purchase pricing rules.
* Fix : Fixing an issue in total discounts float numbers.
* Fix : Fixing an issue in the wccs_cart_item_before_discounted_price hook arguments.
* Fix : Using minimum 3 characters for select products with ajax search.
* Compatibility check with WooCommerce 4.9.0

= 4.10.0 - 03-12-2020 =
* New : Adding the plugin shipping methods to the shipping methods condition.
* New : Adding an option to apply discounts on cart item price to make it compatible with plugins like Name Your Price plugin.
* New : Adding Compatibility with the Custom Product Boxes plugin to total discounts.
* Fix : Checking for customer exists when using WooCommerce customer.
* Fix : Fixing not loading the plugin main page issue when Skyverge plugins are enabled.
* Compatibility check with WooCommerce 4.7.1

= 4.9.0 - 21-10-2020 =
* Fix : Include live price js codes in the product-page shortcode.
* Fix : Fixing issue of applying multiple products group discount on a category.
* Fix : Fixing issue of applying tax on live price total price.
* Fix : Fixing an issue in the condition validator related to not initialized WC session.
* Compatibility check with WooCommerce 4.6.0

= 4.8.0 - 10-09-2020 =
* New : Adding js codes to check min quantity and do not allow to enter a value less than specified min quantity.
* New : Adding shipping city condition.
* New : Allow zero value for fee amount in the checkout fee rules.
* Fix : Does not discount products by simple pricing rules in the Rest API request.
* Fix : Fixed incorrect concatenation of variation sale prices with ".00".
* Fix : Fixing an issue of not considering exclude items in products group rules.
* Dev : Adding arguments to the wccs_product_price_replace_should_replace filter.

= 4.7.0 - 29-07-2020 =
* New : Adding previous days, weeks, months, years condition.
* New : Adding percentage fee option to the bulk and tiered pricing rules.
* New : Adding price fee option to the bulk and tiered pricing rules.
* New : Do not update pricing on yith product options that sold individually.
* New : Setting min quantity of a product based on min quantity in the bulk or tiered pricing rules when this option enabled in the plugin settings.
* Fix : Fixing WC_Background_Process not found issue in older versions of WooCommerce.
* Fix : Fixing an issue in the live price styles.
* Fix : Fixing an issue in searching products with the product title.
* Fix : Fixing updating apply mode in updating shipping condition.
* Fix : Fixing not applying discount on the products when there is a subtotal conditions the pricing rules.
* Fix : Fixing issue of do not setting sale price on cart items that gets discount from the plugin pricing rules.
* Fix : Fixing issue of product price does not change after discount time end in variable products.
* Fix : Fixing product price issue with tax when a simple discount with fixed price applied to a product.
* Fix : Fixing issue of sending cart form data in the ajax request to the live price calculator.

= 4.6.1 - 03-06-2020 =
* Fix : Fixing get_cart issue on woocommerce_init after version 4.6.0 update.

= 4.6.0 - 03-06-2020 =
* New : Adding Total Discounts promotion that will display total discount on cart, checkout and order.
* New : Adding an option to the products list to enable/disable the pagination.
* New : Checking billing email for guest users history like money spent, bought products, etc and it is usefull for first purchase discounts or coupons.
* New : Adding compatibility with WooCommerce Bookings plugin.
* Fix : Fixing a compatibility issue with WooCommerce Smart Coupons Plugin.
* Fix : Reduce number of transients that generated by the plugin.
* Fix : Fixing checkout fees issue with WooCommerce Subscriptions plugin.
* Fix : Change products price only when a simple pricing available.
* Fix : Fixing returning null in the woocommerce_variation_prices filter hook function that caused issue for WooCommerce Product Bundles plugin.
* Compatibility check with WooCommerce 4.2.0

= 4.5.0 - 10-05-2020 =
* New : Using manage_woocommerce capability instead of manage_options capability.
* New : Imporve performance of the plugin in validating products with categories.
* New : Imporove performance of the plugin in validating products with tags.
* Fix : Purchase pricing rules issue when an item from category should receive discount.
* Fix : Checking for cart_discount existance on cart discount hooks.
* Fix : Fixing an issue in checking categories inside the cart.
* Fix : Fixing an issue in tiered pricing rules to apply discount on cheapest products first.
* Fix : Percentage discount calculation issue fixed.
* Fix : Fixing an issue in tiered pricing rules when applying the discount on all products or categories.
* Important : Rename the plugin main file from easy-woocommerce-discounts-pro.php to easy-woocommerce-discounts.php

= 4.4.0 - 19-04-2020 =
* New : Live price improvement to display multiple prices with associated quantities when multiple prices available.
* New : Adding an option to subtotal conditions to exclude selected items subtotal from the cart subtotal.
* New : Adding exclude products for cart discount rules.
* New : Adding exclude items from checkout fees.
* New : Feature to search products by title and sku in product select fields in the plugin backend.
* Fix : Fixing an issue related to caching variable products price.
* Fix : Delete old transients for cached items that increased amount of transients on the database.
* Fix : Fixing categories hierarchy issue in the quantities of categories conditions.

= 4.3.0 - 18-03-2020 =
* New : Adding update products price in background feature.
* Fix : Fixing tax issue in simple pricing rules.
* Fix : Fixing get price suffix issue in the bulk pricing table.
* Fix : Compatibility issue with WooCommerce Currency Switcher(WOOCS) when multiple currency allowed.
* Fix : Fixing cart discount issue with taxes.
* Fix : Percentage discount badge value issue on some themes like flatsome.
* Fix : Percentage badge values can be shown on variable products too.
* Dev : Adding a filter to bulk pricing table to filter its content.

= 4.2.0 - 01-03-2020 =
* New : Adding a feature to show live price always or when a discount available.
* New : Adding jQuery function to get an instance of plugin public javascript classes.
* New : Compatibility of live price with TM Extra Product Options.
* Fix : Fixing issue of updating price in mini cart when quantity updated inside mini cart.
* Fix : Fixing issue of products list in some themes like Electro theme.

= 4.1.0 - 16-02-2020 =
* New : Dispalying discount amount inside sale flash for simple pricing rules, supports both percentage and price discounts.
* New : Adding a shortcode for sale flash.
* Fix : Fixing issue of text translation on multilingual sites.
* Fix : Fixing bulk pricing table prices issue with taxes.
* Fix : Fixing automatically adding free products to the cart with taxes.

= 4.0.0 - 19-01-2020 =
* New : Adding WooCommerce dynamic shipping methods to the plugin.
* New : Adding quantity based purchase pricings.
* New : Adding a feature to add purchase pricing to all variations of a variable product with one purchase rule.
* New : Adding subtotal of regular products condition.
* New : Adding subtotal of onsale products condition.
* Fix : Fixing an issue of auto add to cart when more than 1 bogo rule exists.
* Fix : Fixing an issue in group quantities based on category.

= 3.10.1 - 17-12-2019 =
* Fix : Fixing an issue of showing discounted prices in the cart when apply method is sum.

= 3.10.0 - 28-11-2019 =
* New : Adding compatibility with Booster for WooCommerce multicurrency.
* Fix : Fixing an issue in Automatically adding free products to the cart.

= 3.9.0 - 09-11-2019 =
* New : Adding compatibility with product addons plugin.
* New : Adding a feature to countdown timer to show when discounts available.
* New : Adding at_least_number_of to union type conditions.
* Fix : Fixing an issue in showing html content in purchase messages.
* Fix : Fixing an issue in product meta field check.

= 3.8.3 - 28-09-2019 =
* Fix : Fixing plugin update checker issue.

= 3.8.2 - 28-09-2019 =
* Fix : Fixing live price update on quantity change on some of sites.
* Fix : Checking is WooCommerce card initialized to avoid issues in WooCommerce API.
* Fix : Fixing an issue in BOGO same receive items quantity.
* Fix : Fixing issues related to variable products in live price and quantity table.
* Fix : Fixing issues related to variable product price change.
* Fix : Fixing a compatibility issue with WooCommerce Min/Max Quantity plugin.
* Fix : Fixing issues related to replace variable products prices.
* Fix : Fixing quantity issue in mini cart for purchase pricing rules.
* Fix : Fixing price change issue for simple rules.

= 3.8.1 - 12-08-2019 =
* Fix : Fixing an issue that caused product pricing replace price does not take effect.

= 3.8.0 - 09-08-2019 =
* Important : Rename the plugin folder and main file to easy-woocommerce-discounts-pro to fix conflict issue with the free version.
* New : Adding compatibility with woocommerce subscriptions plugin.
* Fix : Fixing an issue related to replace variable product prices.
* Fix : Fixing an issue related to tiered pricing.

= 3.7.0 - 09.07.2019 =
* New : Adding WooCommerce Countdown Timer feature.
* New : Organize plugin settings.
* Fix : Fixing an issue in cart discounts when cart subtotal is zero.
* Fix : Fixing issue of calculating quantities for variation products.

= 3.6.0 - 18.06.2019 =
* New : Adding an option to settings to display total price in live price.
* New : Adding purchase x receive y same products mode to use it for BOGO rules when buy and get products are same.

= 3.5.0 - 27.05.2019 =
* New : Making bulk pricing table compatible with currency switcher plugins.
* New : Making cart prices compatible with WooCommerce TM Extra Product Options plugin.
* New : Making cart prices compatible with YITH WooCommerce Product Add-ons plugin.

= 3.4.0 - 12.05.2019 =
* New : Adding options to the plugin settings to add sale badge on all types of product pricing rules.
* Fix : Fixing an issue in product quantity based on category.
* Fix : Fixing an issue in purchase pricing rules for categories.

= 3.3.1 - 17.04.2019 =
* Fix : Fixing esc_html issue on quantity table values.

= 3.3.0 - 14.04.2019 =
* Important : Plugin renamed to easy-woocommerce-discounts.
* Important : Plugin text domain renamed to easy-woocommerce-discounts.
* Fix : Fixing quantity table prices issues with taxes for fixed prices.
* Fix : Sanitize user inputs to make it more secure.
* Fix : Escaping outputs to make it more secure.

= 3.2.0 - 22.02.2019 =
* New : Add an option to live price to calculate price by ignoring in the cart quantities of a product.

= 3.1.1 - 16.02.2019 =
* Fix : Fixing an issue in apply subtotal condition pricing on checkout page.
* Fix : Remove exceptions from live price that generate errors.
* Fix : Fix an issue in calculating cart discount amount for percentage discounts.
* New : Add a filter hook for get cart subtotal.

= 3.1.0 - 14.01.2019 =
* New : Automatically add free products to the cart for BOGO rules.

= 3.0.1 - 24.12.2018 =
* Fix : Fixing an issue in product purchase messages.
* Fix : Fixing an issue in html price override.
* Fix : Fixing override of cart item price on ajax add to cart.
* Fix : Fixing issue in the cart items price after adding price override feature.

= 3.0.0 - 22.12.2018 =
* New : Adding new price override feature that override products price in a right way.
* New : Improve performance of the plugin by adding a cache solution.
* New : Adding a cache for products price.
* New : Adding a cache for products quantity table.
* New : Adding a cache for products purchase messages.

= 2.8.0 - 26.11.2018 =
* New : Adding payment method condition to the pricing rules.
* New : Adding shipping method condition to the pricing rules.
* New : Adding shipping country condition to the pricing rules.
* New : Adding shipping state condition to the pricing rules.
* New : Adding shipping postcode condition to the pricing rules.
* New : Adding shipping zone condition to the pricing rules.
* New : Adding an option to control change display price.
* New : Adding an option to control set onsale for products.
* New : Adding discount column to the quantity table.
* New : Adding a shortcode for purchase message.
* New : Adding wccs_quantity_table_quantity filter to quantity table quantity column.
* New : Adding wccs_quantity_table_discount filter to quantity table discount column.
* New : Adding wccs_quantity_table_price filter to quantity table price column.
* New : Adding "before add to cart form" and "after add to cart form" to supported positions of quantity table, purchase message and live price.
* Fix : Fixing an issue in hiding variations quantity table.
* Fix : Do not show price range if min and max are same and only show min in the quantity table.
* Fix : Fixing an issue when user add item to the cart with ajax request.

= 2.7.0 - 12.11.2018 =
* New : Display prices with their associated quantities in the cart.
* New : Adding shortcode support for purchase x receive y rules messages.
* New : Adding colors for purchase x receive y rules text messages.
* New : Removing quantity from purchase and products group rules to make them simple and function like previous versions.
* Fix : Fixing issue of applying tax on discounted prices.
* Fix : Fixing limit discount issue when discount type is fixed price.
* Fix : Fixing discount limit issues.

= 2.6.0 - 11.10.2018 =
* Fix : Fixing issues in purchase x receive y pricing rules.
* Fix : Fixing issues in live price when price is 0.
* Fix : Fixing issue of displaying review in products list shortcode.
* Fix : Fixing reference error in posts_where method.
* New : Adding a feature to caching purchase pricing rules.

= 2.5.0 - 27.09.2018 =
* New : Adding Subtotal of products include tax to the conditions.
* New : Adding Subtotal of products exclude tax to the conditions.
* New : Adding Subtotal of variations include tax to the conditions.
* New : Adding Subtotal of variations exclude tax to the conditions.
* New : Adding Subtotal of categories include tax to the conditions.
* New : Adding Subtotal of categories exclude tax to the conditions.
* New : Adding Subtotal of attributes include tax to the conditions.
* New : Adding Subtotal of attributes exclude tax to the conditions.
* New : Adding Subtotal of tags include tax to the conditions.
* New : Adding Subtotal of tags exclude tax to the conditions.

= 2.4.0 - 22.09.2018 =
* Improvement : Making products & variations & coupons & customers select field as a autocomplete select field.

= 2.3.0 - 19.09.2018 =
* Important : WooCommerce minimum supported version is 3.0.0 from now on.
* New : Adding Checkout Fee rules.
* New : Adding price discount per item to the cart discounts.
* New : Adding percentage discount per item to the cart discounts.
* New : Adding items to cart discounts to apply discount to the specified items in the cart.
* New : Adding a feature to displaying cart discounts name as discount label in the cart.
* New : Adding a feature to combining cart discounts and displaying them as a total discount with specified label from settings.
* New : Rename menu and page title in the Dashboard.
* New : Adding payment method checking condition.
* New : Adding shipping method checking condition.
* New : Adding shipping country checking condition.
* New : Adding shipping state checking condition.
* New : Adding shipping postcode checking condition.
* New : Adding shipping zone checking condition.
* New : Adding styles to the bulk pricing tables.
* New : Adding scroll to the bulk pricing horizontal table.
* New : Adding a feature to apply or not apply cart discounts with individual cart coupons.
* New : Adding a feature to apply or not apply cart discounts with cart regular coupons.
* Fix : Fixing bulk pricing horizontal table labels issue.
* Fix : Fixing cart discount removing issue on WooCommerce 3.2 and above.

= 2.2.4 - 08.09.2018 =
* Fix : Fixing issue of not including tax in adjusted prices when include tax enabled.

= 2.2.3 - 06.08.2018 =
* Fix : Fixing issues in fixed prices.
* New : Adding a shortcode for the live price.

= 2.2.2 - 24.07.2018 =
* Fix : Fixing pricing issues with subtotal conditions.

= 2.2.1 - 15.07.2018 =
* Fix : Do not show live price when discounts are not available for the product.
* Fix : Fixing issue of get_product_attributes in WooCommerce 2.6

= 2.2.0 - 12.07.2018 =
* New : Live price feature that shows discounted price in product page.
* Fix : Fixing products name in select for woocommerce 2.6
* Fix : Fixing repeat issue in products group pricing.
* Fix : Fixing select2 issue in woocommerce 2.6
* Fix : Fixing issue of cart discount coupon in Russian language.

= 2.1.1 - 23.05.2018 =
* Fix : Fixing empty function issue on php 5.5 and previous.

= 2.1.0 - 27.04.2018 =
* New : Adding duplicate rule feature.

= 2.0.0 - 27.03.2018 =
* New : Adding more conditions to products pricing.
* New : Adding more options to discounted products in pricing.
* New : Adding tiered pricing type.
* New : Adding fee adjustment to simple pricing.
* New : Adding a shortcode for bulk pricing table.
* Fix : Making products listing compatible with WooCommerce 3.2 and greater.

= 1.2.0 - 31.12.2017 =
* New : Making Adming UI user friendly.
* New : Adding limit option for cart discount in settings.
* New : Adding limit option for products pricing in settings.
* Fix : Fixing an issue in displaying discounted products.

= 1.1.0 - 23.12.2017 =
* New : Adding products group rule to pricing rules.
* New : Adding exclude products rule to discount and pricing rules.
* New : Adding excluded products from rule to pricing rules.
* New : Adding Apply Mode to pricing and discount rules.
* New : Adding matching mode to conditions and date times.

= 1.0.0 - 26.11.2017 =
* First release.
